/* Petit programme pour stocker la grenouille dans l'EEPROM de l'ATmega328. */

#include <EEPROM.h>

// Déclarations pour l'afficheur OLED :
#include <Adafruit_ssd1306syp.h>
#define broche_SDA 11 // D11 utilisée en sortie.
#define broche_SCL 12 // D12 utilisée en sortie.
Adafruit_ssd1306syp display(broche_SDA, broche_SCL);

// Variables du programme.
byte OCTET;
byte PTR;
// La Grenouille est une matrice de 24 lignes de 5 octets.
// Soit une taille de 120 octets. Le Tableau va de 0 à 119.
byte Grenouille[120] = {0, 0, 48, 0, 0, 0, 56, 0, 0, 0, 124, 0, 0, 0, 124, 0, 
0, 0, 240, 0, 0, 1, 192, 0, 0, 3, 128, 0, 0, 1, 199, 192, 
8, 128, 207, 224, 105, 193, 157, 224, 249, 193, 255, 224, 249, 227, 255, 96, 
121, 231, 255, 224, 59, 239, 255, 192, 27, 127, 255, 0, 27, 127, 255, 0, 
15, 127, 255, 192, 6, 127, 255, 228, 0, 127, 254, 206, 0, 127, 252, 159, 
0, 127, 248, 222, 0, 63, 192, 255, 0, 7, 192, 48, 0, 15, 0, 0, 
0, 30, 0, 0, 0, 15, 28, 0, 0, 7, 248, 0, 0, 3, 248, 0, 
0, 0, 224, 0, 0, 0, 112, 0};

void setup() {
  display.initialize(); delay(100); display.clear();}

void loop() {
  display.setTextSize(1); // Taille simple.
  display.setCursor(0, 17); // X puis Y.
  display.println(" Ecriture des octets");
  display.println("   dans l'EEPROM.");
  display.update();
  delay(2000);
  // Ecriture des octets dans l'EEPROM :
  PTR = 0;
  while (PTR < 120) {
    EEPROM.write(PTR, Grenouille[PTR]);
    PTR++;}

  // Confirmation de la fin du traitement :
  display.clear(); display.setTextSize(1);
  display.setCursor(0, 17);
  display.println("    EEPROM avec");
  display.println("   la GRENOUILLE.");
  display.update();
INFINI: goto INFINI;}

