/*  Utilise la Salamandre inscrite en EEPROM pour l'afficher sur un module OLED SSD1306.
           Par Michel DROUI. (Pseudo Internet : Nulentout.)
    
 ATTENTION : Le LOGO doit déjà être en EEPROM.
 
 D11 : Broche_SDA Pilotage OLED.
 D12 : Broche_SCL Pilotage OLED.
 D13 : LED Verte d'Arduino. (Clignote à 5Hz en boucle de base.)                                                           */
    
// Déclarations pour l'afficheur OLED :
#include <Adafruit_ssd1306syp.h>
#define broche_SDA 11 // D11 utilisée en sortie.
#define broche_SCL 12 // D12 utilisée en sortie.
Adafruit_ssd1306syp display(broche_SDA, broche_SCL);

// Déclarations pour le LOGO.
#include <EEPROM.h>
#define XL 30  // Position du LOGO.
#define YL 25  // Position du LOGO.

// Constantes du programme.
#define LED_Arduino 13

// Variables du programme.
byte OCTET, Ligne, Colonne, PTR; // Pour le LOGO.

void setup() {
  pinMode(LED_Arduino, OUTPUT);
  display.initialize(); delay(300); display.clear(); display.setTextSize(1); // Taille la plus petite.
  //================================= Tracer le LOGO. ===============================
  PTR = 0; // Pointer le premier octet dans l'EEPROM.
  for(Ligne = 0; Ligne < 24; Ligne++)
     {for(Colonne = 0; Colonne < 5; Colonne++) 
         {OCTET = EEPROM.read(PTR);
          for(byte I=0; I < 8; I++)
              {display.drawPixel((Colonne*8)+XL+I, Ligne+YL, (OCTET & B10000000));
               OCTET=OCTET<<1;}; PTR++; } };
  display.drawLine(XL+40, YL+18, XL+40, YL+22,WHITE);
  display.drawLine(XL+41, YL+19, XL+41, YL+21,WHITE);
  display.update();} 
  //=================================================================================

void loop() {
  digitalWrite(LED_Arduino, LOW); delay(100);
  digitalWrite(LED_Arduino, HIGH); delay(100);}

