/* Écriture des textes en EEPROM pour diminuer la place occupée dans la zone
   des variables dynamiques.
   Plus une chaire est longue, plus elle est "rentable". */

#include <EEPROM.h>

int PTR;
char Caractere;
String TEXTE_a_inscrire_en_EEPROM = ""; // Emplacement pour la chaîne entrante.

void setup() { Serial.begin(115200); 
  TEXTE_a_inscrire_en_EEPROM.reserve(30); } // 30 caractères sont très suffisants.

void loop() {  
  PTR = 120; // PTR pointe la première adresse qui suit la table de la Salamandre.
  TEXTE_a_inscrire_en_EEPROM = "NANOMETEO"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Valeur ="; Ecrire_Texte_en_EEPROM(); 
  TEXTE_a_inscrire_en_EEPROM = "F6AAE"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "MAX"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Enregistrements ?"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Modifier Intervalle ?"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "es Heures = "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "es Minutes = "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "es Secondes = "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Nb Jours = "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Capteurs NON OK"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "45 J MAXI : RESET !"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Saisie d"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "C Alarme"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Rappel EEPROM"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Sauvegarde en EEPROM ?"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Altitude = Hauteur = Ref zero ="; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "PAS = 5999e 25Altitude negative.hPa m ft"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Version 15-07-2016"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Effacer les graphes ?"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "SECURITE METEO"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "OUI"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Changer Tmp Alarme ?"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Mode ALTIMETRE ?"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Une graduation = 1J2J2H"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Alarme SONORE ?"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Il en reste : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "SAV historiqueAutomatique : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Duree promenade ?"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "PROFIL"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Graphes pleins ?"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Si B.P."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Chaque Hr : "; Ecrire_Texte_en_EEPROM();
  Lister_EEPROM();
  INFINI: goto INFINI; }
  
void Ecrire_Texte_en_EEPROM(){
  byte Curseur = 0; // Pointer le premier caractère du TEXTE.
  // Ne pas déborder la taille mémoire disponible en EEPROM.
  // N'envoyer que le TEXTE. */
  while ((PTR < 1023) && (TEXTE_a_inscrire_en_EEPROM[Curseur] != '\0')) {
     EEPROM.write(PTR, TEXTE_a_inscrire_en_EEPROM[Curseur]);
     Serial.print(TEXTE_a_inscrire_en_EEPROM[Curseur]); Curseur++; PTR++; }
     EEPROM.write(PTR, 0); PTR++;
  Serial.println(); }
  
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC(); }
  
void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++; } }
  
void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}
   
void Lister_OCTET() {
  byte octet = EEPROM.read(PTR); 
  if ((octet > 31) && (octet < 126)) {Serial.print(' '); Serial.print(char(octet));}
  else Serial.print("..");
  Serial.print(' '); PTR++; }
