/* Écriture des textes en EEPROM pour diminuer la place occupée dans la zone
   des variables dynamiques est déjà effectué avec P02 et ne sera globalement
   plus beaucoup modifié. Par contre, certains détains seront repris. Pour modifier
   la version qui présente une taille constante, ce programme permet de la
   remplacer à la même adresse relative en EEPROM ce qui évite d'avoir à
   reprendre la procédure d'affichage dans le programme. */

#include <EEPROM.h>

int PTR;
char Caractere;
String VERSION_a_inscrire_en_EEPROM = ""; // Emplacement pour la chaîne entrante.

void setup() { Serial.begin(115200); 
  VERSION_a_inscrire_en_EEPROM.reserve(30); } // 30 caractères sont très suffisants.

void loop() {  
  PTR = 407; // PTR pointe la première adresse qui débute la Version.
  VERSION_a_inscrire_en_EEPROM = "Version 15-07-2016"; Ecrire_Texte_en_EEPROM();
  Lister_EEPROM();
  INFINI: goto INFINI; }
  
void Ecrire_Texte_en_EEPROM(){
  byte Curseur = 0; // Pointer le premier caractère du TEXTE.
  // Ne pas déborder la taille mémoire disponible en EEPROM.
  // N'envoyer que le TEXTE. */
  while ((PTR < 1023) && (VERSION_a_inscrire_en_EEPROM[Curseur] != '\0')) {
     EEPROM.write(PTR, VERSION_a_inscrire_en_EEPROM[Curseur]);
     Serial.print(VERSION_a_inscrire_en_EEPROM[Curseur]); Curseur++; PTR++; }
     EEPROM.write(PTR, 0); PTR++;
  Serial.println(); }
  
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC(); }
  
void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++; } }
  
void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}
   
void Lister_OCTET() {
  byte octet = EEPROM.read(PTR); 
  if ((octet > 31) && (octet < 126)) {Serial.print(' '); Serial.print(char(octet));}
  else Serial.print("..");
  Serial.print(' '); PTR++; }
